# -*- coding: utf-8 -*-
"""
Created on Wed Aug  7 20:25:48 2019

@author: Nezam Avaran
"""
import numpy as np
from random import seed
from random import random
import matplotlib.pyplot as plt
from keras.models import Model ,load_model
from keras import backend as K
from keras.layers import *
from keras.layers.merge import concatenate as concat
import numpy as np
import scipy.io as sio
import h5py
from keras.callbacks import EarlyStopping
from keras.losses import *
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import keras
from os import listdir,makedirs
from os.path import isfile, join
from keras.callbacks import ModelCheckpoint
from PIL import Image
import sys
import tensorflow as tf
from matplotlib.pyplot import imshow
import matplotlib.pyplot as plt
from sklearn.metrics import mean_squared_error as msqe

# seed random number generator
#seed(1)
#trdata_path_landmark = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\trdata\\input_data\\'
#trdata_path_alpha = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\trdata\\output_data\\'
#tstdata_path_landmark = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\tstdata\\input_data\\'
#tstdata_path_alpha = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\tstdata\\output_data\\'
#data_path = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\Linear_regression\\NN\\training\\'
data_path = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\denoising\\training\\'
#file_list = [f for f in listdir(trdata_path_landmark) if isfile(join(trdata_path_landmark, f))]
#file_list_test = [f for f in listdir(tstdata_path_landmark) if isfile(join(tstdata_path_landmark, f))]

#data_path_load = r'E:/Kamyab_data/denoising/'
data_path_load = r'F:\\Kamyab_data\\IR_BE\\deepLearning\\denoising\\data\\'
bs=20


trdata = sio.loadmat(data_path_load + 'data_GT_imgnet.mat')['data_grid']
trdata = np.array(trdata)
#trdata = np.expand_dims(trdata , axis = -1)

trdata_noisy = sio.loadmat(data_path_load + 'data_noisy_imgnet.mat')['data_grid_noisy']
trdata_noisy = np.array(trdata_noisy)
#trdata_noisy = np.expand_dims(trdata_noisy , axis = -1)

def forward(zhat):
    return zhat + 0.03*K.random_normal(shape=(bs, 64,64,3), mean=0., stddev=1.)

def tapered_loss(y_true, y_pred):
    return 10 - K.log(K.exp(-K.square(y_true-y_pred)) + 10)

def reg_loss(y_true, y_pred):
    recon = K.mean(mean_squared_error(y_true, y_pred))
    reg = K.sqrt(K.sum(K.square(x_clean)))
    return recon #+ 0.01*reg

def reg_loss_test(y_true, y_pred):
    recon = K.mean(mean_squared_error(y_true, y_pred))
    reg = K.sqrt(K.sum(K.square(x_clean2)))
    return recon #+ 0.01*reg

input_shape = (64,64,3)
input_noisy = Input(input_shape,name='noisy_in') 

statistical_test_run_num = 10
MSE_z = np.zeros(statistical_test_run_num)
clean_pred_z = np.zeros((statistical_test_run_num,500,64,64,3))
for j in range(statistical_test_run_num):

    conv1 = Conv2D(name = 'enc_2d_h1', filters=4, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='tanh', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    conv2 = Conv2D(name = 'enc_2d_h2', filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='tanh', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    conv3 = Conv2D(name = 'enc_2d_h3', filters=16, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='tanh', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    conv4 = Conv2D(name = 'enc_2d_h4', filters=32, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='tanh', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    deconv1 = Conv2DTranspose(name = 'dec_2d_h1', filters=32, kernel_size=3, strides=(2,2), padding='same', output_padding=None,  data_format='channels_last',  activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    deconv2 = Conv2DTranspose(name = 'dec_2d_h2', filters=16, kernel_size=3, strides=(2,2), padding='same', output_padding=None,  data_format='channels_last',  activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    deconv3 = Conv2DTranspose(name = 'dec_2d_h3', filters=8, kernel_size=3, strides=(2,2), padding='same', output_padding=None,  data_format='channels_last',  activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    deconv4 = Conv2DTranspose(name = 'dec_2d_h4', filters=4, kernel_size=3, strides=(2,2), padding='same', output_padding=None,  data_format='channels_last',  activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    conv_out = Conv2D(name = 'clean_out', filters=3, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    forward_out = Lambda(forward, output_shape = (64,64,3),name='forward')
    
        
    x2 = conv1(input_noisy)
    xx2 = conv2(x2)
    x2 = conv3(x2)
    x2 = conv4(x2)
    x2 = deconv1(x2)
    x2 = concatenate([x2,xx2])
    x2 = deconv2(x2)
    x2 = deconv3(x2)
    x2 = deconv4(x2)
    x_clean2 = conv_out(x2)
    
    
    denoiser_test = Model(inputs = input_noisy , outputs = x_clean2)
    
     
    test_noisy = sio.loadmat(data_path_load + 'test_data_noisy_imgnet.mat')['test_data_grid_noisy']
    test_noisy = np.array(test_noisy)
#    test_noisy = np.expand_dims(test_noisy , axis = -1)
    test_clean = sio.loadmat(data_path_load +'test_data_GT_imgnet.mat')['test_data_grid']
    test_clean = np.array(test_clean)
#    test_clean = np.expand_dims(test_clean , axis = -1)
    
    
    
    save_path = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\denoising\\result\\'
    denoiser_test.compile(optimizer = 'Adam' , loss = reg_loss_test)
    
    #    denoiser_test.load_weights(data_path+'denoiser_w_z_imgnet.h5')
    
    history_tstdenoising = denoiser_test.fit(trdata_noisy, trdata, batch_size = bs, epochs = 20, validation_split=0.2)#fit_generator(Generator_IR(batch_size,trdata_path_landmark,trdata_path_alpha), steps_per_epoch =1000, epochs =10,validation_data=Generator_IR_Test(batch_size,tstdata_path_landmark,tstdata_path_alpha), validation_steps=100)#,callbacks=[checkpointer])
    
    denoiser_test.save_weights(data_path+'denoiser_w_z_imgnet.h5')
    
    clean_pred_z[j,:,:,:,:] = np.squeeze(denoiser_test.predict(test_noisy))

#sio.savemat('clean_pred_fz.mat', {'clean_pred_fz': clean_pred_fz})
res_path = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\denoising\\result\\'


sio.savemat(res_path + 'clean_pred_z_imgnet.mat', {'clean_pred_z': clean_pred_z})

