close all;
siz = 64;

l = [100 100 ; 100 50 ; 100 20 ; 100 10 ; 100 5];

% Create Thin-Plate convolutional mask
w = zeros(siz,siz);

m = [0  0  1  0 0;
    0  2 -8  2 0;
    1 -8 20 -8 1;
    0  2 -8  2 0;
    0  0  1  0 0];
for i=1:5, for j=1:5,
        w(1+rem(siz-3+i,siz),1+rem(siz-3+j,siz)) = m(i,j);
    end; end;

% Invert this to get covariance

% w(1,1) = 20 + 10^(1-4*log10(l(1,1)));  % to give alpha perturbation Eq()
% r1 = real(ifft2(1./ real(fft2(w))));
% r1(:) = r1 / r1(1,1);
% 
% 
% % Create sample
% l=real(fft2(r1));
% load test_data test_data
for i = 1 : 500
    u = randi([10,200]);
    w(1,1) = 20 + 10^(1-4*log10(u));  % to give alpha perturbation Eq()
    r1 = real(ifft2(1./ real(fft2(w))));
    r1(:) = r1 / r1(1,1);
    
    
    % Create sample
    l=real(fft2(r1));
    f=real(ifft2(sqrt(l).*fft2(randn(siz))));
    f=(f-min(f(:)))/(max(f(:))-min(f(:)));
    ff = f(:);
    sigma = 0.3*rand;
    f_noisy = ff+ sigma*randn(size(ff));
    num_of_outlier_pixels = round(-5*log(rand));
    inds = randperm(length(ff));
    f_out = ff;
    f_out(inds(1:num_of_outlier_pixels)) = rand;
    % figure;subplot(1,2,1);imshow(reshape(f,64,64));colormap gray;subplot(1,2,2);imshow(reshape(f_noisy,64,64));colormap gray
    test_data(i , :) = ff;
    test_data_grid(i,:,:) = f;
    test_data_noisy(i , :) = f_noisy;
    test_data_grid_noisy(i , :,:) = reshape(f_noisy, [64,64]);
end



% load data data
for i = 1 : 5000
    i
    u = 100;%randi([10,200]);
    w(1,1) = 20 + 10^(1-4*log10(u));  % to give alpha perturbation Eq()
    r1 = real(ifft2(1./ real(fft2(w))));
    r1(:) = r1 / r1(1,1);
    
    
    % Create sample
    l=real(fft2(r1));
    f=real(ifft2(sqrt(l).*fft2(randn(siz))));
    f=(f-min(f(:)))/(max(f(:))-min(f(:)));
    ff = f(:);
    sigma = 0.3;%0.3*rand;
    f_noisy = ff+ sigma*randn(size(ff));
    num_of_outlier_pixels = round(-5*log(rand));
    inds = randperm(numel(ff));
%     f_out = ff;
    f_noisy(inds(1:num_of_outlier_pixels)) = rand;
    figure;subplot(1,2,1);imshow(reshape(f,64,64));colormap gray;subplot(1,2,2);imshow(reshape(f_noisy,64,64));colormap gray
%     data(i , :) = ff;
%     data_grid(i,:,:) = f;
%     data_noisy(i , :) = f_noisy;
%     data_grid_noisy(i , :,:) = reshape(f_noisy, [64,64]);
    eval(sprintf('test_sample_clean_u_%d_s_%d = f;',u, round(sigma*10)));
    eval(sprintf('test_sample_noisy_u_%d_s_%d = reshape(f_noisy, [64,64]);',u, round(sigma*10)));
    save(sprintf('test_sample_clean_u_%d_sigma_%d',u,round(sigma*10)),sprintf('test_sample_clean_u_%d_s_%d',u,round(sigma*10)));
    save(sprintf('test_sample_noisy_u_%d_sigma_%d',u,round(sigma*10)),sprintf('test_sample_noisy_u_%d_s_%d',u,round(sigma*10)))
end
% figure;subplot(3,2,1);imshow(squeeze(data_grid(i,:,:)));
% subplot(3,2,2);imshow(squeeze(data_grid_noisy(i,:,:)));
% subplot(3,2,3);imshow(squeeze(data_grid(i-1,:,:)));
% subplot(3,2,4);imshow(squeeze(data_grid_noisy(i-1,:,:)));
% subplot(3,2,5);imshow(squeeze(data_grid(i-2,:,:)));
% subplot(3,2,6);imshow(squeeze(data_grid_noisy(i-2,:,:)));

t = reshape(data_grid,[5000,4096]);
t_n = reshape(data_grid_noisy,[5000,4096]);
for i = 1 : 5000
    %     mse(i) = immse(t(i,:),t_n(i,:));
    SNR_me(i) = snr(data_grid(i,:), data_grid_noisy(i,:));
end
% mean(mse)
% std(mse)
mean(SNR_me)
std(SNR_me)
% c = cov(data);
% covar_zohreh=c;
% mu_zohreh = mean(data);
% mu_noisy = mean(data_noisy);
% covar_noisy = cov(data_noisy);
% save covar_zohreh covar_zohreh -v7.3
% save mu_zohreh mu_zohreh -v7.3
% save covar_noisy covar_noisy -v7.3
% save mu_noisy mu_noisy -v7.3
% save data data -v7.3
% save data_noisy data_noisy -v7.3
% save test_data test_data -v7.3
% save test_data_noisy test_data_noisy -v7.3
% save data_grid data_grid -v7.3
% save data_grid_noisy data_grid_noisy -v7.3
% save test_data_grid test_data_grid -v7.3
% save test_data_grid_noisy test_data_grid_noisy -v7.3
save_path = 'F:\Kamyab_data\IR_BE\deepLearning\denoising\data\';
save([save_path,'data_grid.mat'], 'data_grid');
save ([save_path,'data_grid_noisy.mat'], 'data_grid_noisy');
save ([save_path,'test_data_grid.mat'], 'test_data_grid');
save ([save_path,'test_data_grid_noisy.mat'], 'test_data_grid_noisy');