close all;
clear;
res_path = 'F://Kamyab_data//IR_BE//deepLearning//denoising//result//';
gt_path = 'F://Kamyab_data//IR_BE//deepLearning//denoising//data//';
load([res_path, 'clean_pred_z']);
load([res_path, 'clean_pred_fz']);
load([gt_path, 'test_data_grid']);
load([gt_path, 'test_data_grid_noisy']);
load([res_path, 'MSE_DRN']);

for i = 1 : 10
    pred_z = squeeze(clean_pred_z(i,:,:,:));
    pred_fz = squeeze(clean_pred_fz(i,:,:,:));
    gt = test_data_grid;
    for j = 1 : 500
        MSE_DM_tr_NO_tst_NO(i,j) = immse(pred_z(j,:,:),gt(j,:,:));
        MSE_DC_tr_NO_tst_NO(i,j) = immse(pred_fz(j,:,:),gt(j,:,:));
    end
end
MSE_DM_tr_NO_tst_NO = mean(MSE_DM_tr_NO_tst_NO,2);
MSE_DC_tr_NO_tst_NO = mean(MSE_DC_tr_NO_tst_NO,2);
MSE_DRN_tst_NO = repmat(mean(MSE_DR), [10,1]);

P_DM_DC = signrank(MSE_DM_tr_NO_tst_NO, MSE_DC_tr_NO_tst_NO)
P_DM_DRN = signrank(MSE_DM_tr_NO_tst_NO, MSE_DRN_tst_NO)
P_DC_DRN = signrank(MSE_DC_tr_NO_tst_NO, MSE_DRN_tst_NO)

mean(MSE_DM_tr_NO_tst_NO)
std(MSE_DM_tr_NO_tst_NO)

mean(MSE_DC_tr_NO_tst_NO)
std(MSE_DC_tr_NO_tst_NO)

mean(MSE_DRN_tst_NO)
std(MSE_DRN_tst_NO)

viz_ind = [1,2,3,4,5];
for j = 1 : length(viz_ind)
    viz_in{j}= squeeze(test_data_grid_noisy(viz_ind(j),:,:));
    viz_gt{j}= squeeze(test_data_grid(viz_ind(j),:,:));
for i = 1 : 10
    viz_pred_z(i,:,:)=squeeze(clean_pred_z(i,viz_ind(j),:,:));
    viz_pred_fz(i,:,:)=squeeze(clean_pred_z(i,viz_ind(j),:,:));
end
viz_pred_DR = squeeze(denoising_deep_reg_quasi(squeeze(test_data_grid_noisy(viz_ind(j),:))));
viz_pred_DR =reshape(viz_pred_DR,[64,64]);
mean_pred_z = squeeze(mean(viz_pred_z,1));
mean_pred_fz = squeeze(mean(viz_pred_fz,1));
subplot( length(viz_ind),5,5*(j-1)+1); imshow(viz_gt{j});
subplot( length(viz_ind),5,5*(j-1)+2); imshow(viz_in{j});
subplot( length(viz_ind),5,5*(j-1)+3); imshow(mean_pred_z);
subplot( length(viz_ind),5,5*(j-1)+4); imshow(mean_pred_fz);
subplot( length(viz_ind),5,5*(j-1)+5); imshow(viz_pred_DR);
end
t = reshape(test_data_grid , [500, 4096]);
tt = reshape(test_data_grid_noisy , [500, 4096]);
for i = 1 : 500
avg_mse_in(i) = immse(t(i,:),tt(i,:));
end
mean(avg_mse_in)
std(avg_mse_in)

% p_DM_DC_tr_NO = signrank(MSE_DM_tr_NO_tst_NO,MSE_DC_tr_NO_tst_NO)
% load([res_path,'MSE_DM_tr_NO_tst_NO']);
% load([res_path,'MSE_DM_tr_N_tst_NO']);
% load([res_path,'MSE_DC_tr_NO_tst_NO']);
% load([res_path,'MSE_DC_tr_N_tst_NO']);


% p_DM_DC_tr_n = signrank(MSE_DM_tr_N_tst_NO, MSE_DC_tr_N_tst_NO)
% p_DM_DR_tr_n = signrank(MSE_DM_tr_N_tst_NO, MSE_dr)
% p_DC_DR_tr_n = signrank(MSE_DC_tr_N_tst_NO, MSE_dr)


% p_DM_DC_tr_NO = signrank(MSE_DM_tr_NO_tst_NO, MSE_DC_tr_NO_tst_NO)
% p_DM_DR_tr_NO = signrank(MSE_DM_tr_NO_tst_NO, MSE_dr)
% p_DC_DR_tr_NO = signrank(MSE_DC_tr_NO_tst_NO, MSE_dr)

