# -*- coding: utf-8 -*-
"""
Created on Wed Aug  7 20:25:48 2019

@author: Nezam Avaran
"""
import numpy as np
from random import seed
from random import random
import matplotlib.pyplot as plt
from keras.models import Model ,load_model
from keras import backend as K
from keras.layers import *
from keras.layers.merge import concatenate as concat
import numpy as np
import scipy.io as sio
import h5py
from keras.callbacks import EarlyStopping
from keras.losses import *
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import keras
from os import listdir,makedirs
from os.path import isfile, join
from keras.callbacks import ModelCheckpoint
from PIL import Image
import image_slicer
import sys
import random
from keras import regularizers
from keras import layers
from sklearn.metrics import mean_squared_error


# seed random number generator
seed(1)
# generate some random number
N = 500 # number of sample points
N_tr = 6000 # number of training data
ref_alpha =  np.random.random((N_tr,1))*8 #slop angle, feasible range = [0,1]
ref_b = np.random.random((N_tr,1))*10 # arz az mabda'a, feasible range = [-5,5]
#xi = 0.5; # threshold of Capped function
z = [ref_alpha, ref_b];
#generate samples for regression problem

batch_size=10
max_val = 1;
min_val = -1;
cc = 1;
x_data  = np.random.rand(N_tr,N) * (max_val - min_val) + min_val
samples = np.zeros((N_tr,N))
# add noise to 40% of points in each record and turn 10% of points in each record to outlier
for i in range(N_tr):
    mus = 0
    sigmas = np.random.random()
    num_of_outliers = 0#int(-5*np.log(np.random.random()))+1
    n_noise = N - num_of_outliers
    samples[i,num_of_outliers:500] = x_data[i,num_of_outliers:500]*np.tile(ref_alpha[i],(1,n_noise)) + np.tile(ref_b[i], (1,n_noise))+ np.random.normal(mus, sigmas, size=(1,n_noise))
    samples[i, 0:num_of_outliers]= 1/(np.random.random(size=(1,num_of_outliers)))#np.random.exponential(scale=5.0, size=(1,50))# x_data[:, 0:50]*np.tile(ref_alpha, (1,50)) + np.tile(ref_b, (1,50)) + 10*np.random.randn(N_tr,50)

indices = np.arange(N_tr)
np.random.shuffle(indices)
samples = samples[indices]
x_data = x_data[indices]
ref_alpha = ref_alpha[indices]
ref_b = ref_b[indices]
#samples, x_data, ref_alpha, ref_b = random.shuffle(samples, x_data, ref_alpha, ref_b, random_state=0)

x_data_test  = sio.loadmat('x_data_test2.mat')['samples_x']#np.random.rand(batch_size,N) * (max_val - min_val) + min_val
x_data_test = np.tile(x_data_test , (batch_size , 1))
samples_test = sio.loadmat('samples_test2.mat')['samples_y']
samples_test = np.tile(samples_test , (batch_size , 1))

N_tst=500
x_data_test2  = np.random.rand(N_tst,N) * (max_val - min_val) + min_val
samples_test2 = np.zeros((N_tst,N))
ref_alpha_tst2 = np.random.random((N_tst,1))*8 #slop angle, feasible range = [0,1]
ref_b_tst2 = np.random.random((N_tst,1))*10 # arz az mabda'a, feasible range = [-5,5]

# add noise to 40% of points in each record and turn 10% of points in each record to outlier
for i in range(N_tst):
    mus = 0
    sigmas = np.random.random()
    num_of_outliers = int(-5*np.log(np.random.random()))+1
    n_noise = N - num_of_outliers
    samples_test2[i,num_of_outliers:500] = x_data_test2[i,num_of_outliers:500]*np.tile(ref_alpha_tst2[i],(1,n_noise)) + np.tile(ref_b_tst2[i], (1,n_noise)) + np.random.normal(mus, sigmas, size=(1,n_noise))
    samples_test2[i, 0:num_of_outliers]= 1/(np.random.random(size=(1,num_of_outliers)))#np.random.exponential(scale=5.0, size=(1,50))# x_data[:, 0:50]*np.tile(ref_alpha, (1,50)) + np.tile(ref_b, (1,50)) + 10*np.random.randn(N_tr,50)

indices = np.arange(N_tst)
np.random.shuffle(indices)
samples_test2 = samples_test2[indices]
x_data_test2 = x_data_test2[indices]
ref_alpha_tst2 = ref_alpha_tst2[indices]
ref_b_tst2 = ref_b_tst2[indices]


def forward(args):
    alpha, beta, data_x=args
    return alpha*data_x +beta# + K.random_normal(shape=(batch_size, N), mean=0., stddev=1.)
#    return K.sum(K.dot(alpha,xx),beta)

def tapered_loss(y_true, y_pred):
    return 10 - K.log(K.exp(-K.square(y_true-y_pred)) + 10)

def metric_z_zhat(y_true, y_pred):
    t1 = K.mean(mean_squared_error(a, ref_alpha))
    t2 = K.mean(mean_squared_error(b, ref_b))
    return t1 + t2


input_shape = (N,)

statistical_test_run_num = 10
MSE_fz = np.zeros(statistical_test_run_num)
MSE_fz2 = np.zeros((statistical_test_run_num,N_tst))
aa_fz = np.zeros(statistical_test_run_num)
bb_fz = np.zeros(statistical_test_run_num)
t_aa = np.zeros((statistical_test_run_num,N_tst))
t_bb = np.zeros((statistical_test_run_num,N_tst))
for j in range(statistical_test_run_num):
    input_y = Input(input_shape,name='lin_reg_y') 
    input_x = Input(input_shape,name='lin_reg_x') 
    
    dense1 = Dense(300,name = 'en_d1', activation='relu')#, filters=4, kernel_size=3, strides=(1,1), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense2 = Dense(200,name = 'en_d2', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense3 = Dense(100,name = 'en_d3', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense4 = Dense(50,name = 'en_d4', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense4_5 = Dense(50,name = 'en_d4_5', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    
    dense5 = Dense(20,name = 'en_d5', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense6 = Dense(10,name = 'en_d6', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    dense6_5 = Dense(10,name = 'en_d6_5', activation='relu')
    
    dense7 = Dense(5,name = 'en_d7', activation='relu')#, filters=8, kernel_size=3, strides=(2,2), padding='same', data_format='channels_last', dilation_rate=(1, 1), activation='relu', use_bias=True, kernel_initializer='glorot_uniform', bias_initializer='zeros', kernel_regularizer=None, bias_regularizer=None, activity_regularizer=None, kernel_constraint=None, bias_constraint=None)
    
    
    dense8 = Dense(1, name = 'alphahat', activation='linear')#, activity_regularizer=regularizers.l2(0.01))
    
    dense9 = Dense(1, name = 'betabahat', activation='linear')#, activity_regularizer=regularizers.l2(0.01))
    
    x = dense1(input_y)
    x = dense2(x)
    x = dense3(x)
    x = dense4(x)
    xx = dense4_5(x)
    x = layers.add([x,xx])
    x = dense5(x)
    x = dense6(x)
    xx = dense6_5(x)
    x = layers.add([x,xx])
    x = dense7(x)
    a = dense8(x)
    b = dense9(x)
    #latent_concat = concat([a,b,input_x],name='latent_concat')
    y = Lambda(forward, output_shape = (N, ),name='forward')([a,b, input_x])
    
    linear_regressor = Model(inputs = [input_x, input_y] , outputs = y)
    
    x2 = dense1(input_y)
    x2 = dense2(x2)
    x2 = dense3(x2)
    x2 = dense4(x2)
    xx21 = dense4_5(x2)
    x2 = layers.add([x2 , xx21])
    x2 = dense5(x2)
    x2 = dense6(x2)
    xx22 = dense6_5(x2)
    x2 = layers.add([x2,xx22])
    x2 = dense7(x2)
    a2 = dense8(x2)
    b2 = dense9(x2)
    linear_regressor_test = Model(inputs = [input_x, input_y] , outputs = [a2,b2])
    linear_regressor_test.summary()
    linear_regressor.compile(optimizer = 'Adam' , loss = 'mean_squared_error')#, metrics = [ metric_z_zhat])
    #linear_regressor.compile(optimizer = 'Adam' , loss = tapered_loss)
    #history_lin_reg = linear_regressor.fit(np.tile(np.transpose(samples[:,1]),(N,1)), np.tile(np.transpose(data_x),(N,1)),  batch_size=10, epochs = 100)
    
    history_lin_reg_fz = linear_regressor.fit([x_data, samples], samples,  batch_size=64, epochs = 20)
   
    t_a, t_b = linear_regressor_test.predict([x_data_test, samples_test])#(np.tile(np.transpose(samples[:,1]),(N,1)))
    aa_fz[j] = t_a[0]
    bb_fz[j] = t_b[0]
    pred_line = aa_fz[j]*x_data_test + bb_fz[j]
    ref_line = 0.5*x_data_test + 3
    MSE_fz[j] = mean_squared_error(ref_line, pred_line)
    for k in range(N_tst):
        t_aa[j,k],t_bb[j,k] = linear_regressor_test.predict([x_data_test2[k,:].reshape(1,-1),samples_test2[k,:].reshape(1,-1)])
        pred_line2 = t_aa[j,k]*x_data_test2[k,:] + t_bb[j,k]
        ref_line2 = ref_alpha_tst2[k]*x_data_test2[k,:] + ref_b_tst2[k]
        MSE_fz2[j,k] = mean_squared_error(ref_line2, pred_line2)

res_path = 'F:\\Kamyab_data\\IR_BE\\deepLearning\\linear_regression\\result\\'
sio.savemat(res_path + 'MSE_DC_tr_N_tst_NO2.mat' , {'MSE_DM_tr_NO_tst_NO': MSE_fz})
sio.savemat(res_path + 'a_DC_tr_N_tst_NO2.mat' , {'a_DM_tr_NO_tst_NO': aa_fz})
sio.savemat(res_path + 'b_DC_tr_N_tst_NO2.mat' , {'b_DM_tr_NO_tst_NO': bb_fz})
sio.savemat(res_path + 'MSE_DC_tr_N_tst_NO2_st.mat' , {'MSE_DM_tr_NO_tst_NO_st': MSE_fz2})
sio.savemat(res_path + 'a_DC_tr_N_tst_NO2_st.mat' , {'a_DM_tr_NO_tst_NO_st': t_aa})
sio.savemat(res_path + 'b_DC_tr_N_tst_NO2_st.mat' , {'b_DM_tr_NO_tst_NO_st': t_bb})
