# -*- coding: utf-8 -*-
"""
Created on Thu Apr 23 10:49:01 2020

@author: shima
"""
import numpy as np
from random import seed
from random import random
import matplotlib.pyplot as plt
from keras.models import Model ,load_model
from keras import backend as K
from keras.layers import *
from keras.layers.merge import concatenate as concat
import scipy.io as sio
import h5py
from keras.callbacks import EarlyStopping
from keras.losses import *
from mpl_toolkits.mplot3d import Axes3D
import matplotlib.pyplot as plt
import keras
from os import listdir,makedirs
from os.path import isfile, join
from keras.callbacks import ModelCheckpoint
from PIL import Image
import image_slicer
import sys
import random
from keras import regularizers
from keras import layers
from sklearn.metrics import mean_squared_error
import torch
import torch.nn as nn
import sys
# insert at 1, 0 is the script path (or '' in REPL)
sys.path.insert(1, 'F:/Kamyab_data/IR_BE/deepLearning/')
import FrEIA.FrEIA.framework as Ff
import FrEIA.FrEIA.modules as Fm


seed(1)
# generate some random number
N = 500 # number of sample points
N_tr = 6000 # number of training data
ref_alpha = np.random.random((N_tr,1))*8 #slop angle, feasible range = [0,1]
ref_b = np.random.random((N_tr,1))*10 # arz az mabda'a, feasible range = [-5,5]
xi = 0.5; # threshold of Capped function
z = [ref_alpha, ref_b];
#generate samples for regression problem

batch_size=10
max_val = 1;
min_val = -1;
cc = 1;

x_data  = np.random.rand(N_tr,N) * (max_val - min_val) + min_val
samples = np.zeros((N_tr,N))


# add noise to 40% of points in each record and turn 10% of points in each record to outlier
samples[:, 50:500]= x_data[:, 50:500]*np.tile(ref_alpha, (1,450)) + np.tile(ref_b, (1,450)) + np.random.randn(N_tr,450)
samples[:, 0:50]= x_data[:, 0:50]*np.tile(ref_alpha, (1,50)) + np.tile(ref_b, (1,50)) + 10*np.random.randn(N_tr,50)

#samples = x_data*np.tile(ref_alpha, (1,500)) + np.tile(ref_b, (1,500))# + np.random.randn(1000,N)


#samples, x_data = random.shuffle(samples, x_data, random_state=0)
x_data_test  = sio.loadmat('x_data_test2.mat')['samples_x']#np.random.rand(batch_size,N) * (max_val - min_val) + min_val
x_data_test = np.tile(x_data_test , (batch_size , 1))
samples_test = sio.loadmat('samples_test2.mat')['samples_y']
samples_test = np.tile(samples_test , (batch_size , 1))
#    samples[i,:]=x[i,:]

nodes = [Ff.InputNode(500, name='input')]

nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':300},
                       'clamp':4,
                      },
                      name='fc1'))


nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':1}, name='permute_{}'.format(i)))
  

nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':200},
                       'clamp':4,
                      },
                      name='fc2'))

nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':2}, name='permute_{}'.format(i)))


nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':100},
                       'clamp':4,
                      },
                      name='fc3'))

nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':3}, name='permute_{}'.format(i)))


fc_50 = Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':50},
                       'clamp':4,
                      },
                      name='fc4')
nodes.append(fc_50)

nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':50},
                       'clamp':4,
                      },
                      name='fc5'))


nodes.append(Ff.Node([nodes[-1].out0, fc_50.out0],
                     Fm.Concat1d, {'dim':0}, name='concat1'))

nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':4}, name='permute_{}'.format(i)))


nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':20},
                       'clamp':4,
                      },
                      name='fc6'))

nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':5}, name='permute_{}'.format(i)))

fc_10 = Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':10},
                       'clamp':4,
                      },
                      name='fc7')
nodes.append(fc_10)

nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':10},
                       'clamp':4,
                      },
                      name='fc5'))



nodes.append(Ff.Node([nodes[-1].out0, fc_10.out0],
                     Fm.Concat1d, {'dim':0}, name='concat2'))

nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':6}, name='permute_{}'.format(i)))


nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':5},
                       'clamp':4,
                      },
                      name='fc5'))
nodes.append(Ff.Node([nodes[-1].out0], Fm.permute_layer, {'seed':7}, name='permute_{}'.format(i)))

nodes.append(Ff.Node([nodes[-1].out0],Fm.rev_multiplicative_layer, 
                      {'F_class':Fm.F_fully_connected, 
                       'F_args':{'internal_size':2},
                       'clamp':4,
                      },
                      name='fc5'))

    # if c.use_permutation:
# nodes.append(Node([nodes[-1].out0], permute_layer, {'seed':i}, name='permute_{}'.format(i)))
        

nodes.append(Ff.OutputNode(nodes[-1], name='output'))

fc_inn = Ff.ReversibleGraphNet(nodes)

loss_fn = torch.nn.MSELoss(reduction='sum')
learning_rate = 1e-4
optimizer = torch.optim.Adam(fc_inn.parameters(), lr=learning_rate)
x = torch.randn(1000, 500)
y = torch.randn(1000,2)
yy = torch.cat([torch.zeros(1000,999), y] , dim= -1)
yy = torch.cat([yy , torch.zeros(1000,999)], dim = -1)
for t in range(500):
    # Forward pass: compute predicted y by passing x to the model.
    y_pred = fc_inn(x)

    # Compute and print loss.
    loss = loss_fn(y_pred, yy)
    if t % 100 == 99:
        print(t, loss.item())
        
    optimizer.zero_grad()

    # Backward pass: compute gradient of the loss with respect to model
    # parameters
    loss.backward()

    # Calling the step function on an Optimizer makes an update to its
    # parameters
    optimizer.step()

